/*
 * Copyright 2016 - 2022 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <ox/claw/claw.hpp>

#include "preload.hpp"

namespace ox {

static ox::Error buildPreloadBuffer(ox::Buffer *buff, std::size_t buffStart, ox::FileSystem *fs,
                                    ox::TypeStore *ts, const char *path) noexcept {
	oxRequire(files, fs->ls(path));
	for (const auto &f : files) {
		oxRequire(stat, fs->stat(f));
		if (stat.fileType == ox::FileType::NormalFile) {
			oxRequire(fileBuff, fs->read(path));
			oxRequire(obj, ox::readClaw(ts, fileBuff));
		} else if (stat.fileType == ox::FileType::Directory) {
			const auto childPath = ox::sfmt("{}/{}", path, f);
			oxReturnError(buildPreloadBuffer(buff, buffStart, fs, ts, childPath.c_str()));
		}
	}
	return {};
}

ox::Result<ox::Buffer> buildPreloadBuffer(std::size_t buffStart, ox::FileSystem *fs, ox::TypeStore *ts) noexcept {
	ox::Buffer buff;
	oxReturnError(buildPreloadBuffer(&buff, buffStart, fs, ts, "/"));
	return buff;
}

}